package org.rcisoft.app.appOpmTopic.controller;


/*固定导入*/

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import org.rcisoft.business.opmTopic.entity.OpmTopic;
import org.rcisoft.business.opmTopic.service.OpmTopicService;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/app")
public class AppOpmTopicController extends CyPaginationController<OpmTopic> {
    @Autowired
    private OpmTopicService opmTopicServiceImpl;

    @PreAuthorize("@cyPerm.hasPerm('app:topic:detial')")
    @CyOpeLogAnno(title = "system-公告管理-查询公告", businessType = CyLogTypeEnum.QUERY)
    @Operation(summary = "查询单一公告", description = "查询单一公告")
    @Parameters({@Parameter(name = "businessId", description = "businessId", required = true)})
    @GetMapping("/open/opmTopic/detail/{businessId:\\w+}")
    public CyResult detail(@PathVariable Integer businessId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                opmTopicServiceImpl.findById(businessId));
    }

    @PreAuthorize("@cyPerm.hasPerm('app:topic:query')")
    @CyOpeLogAnno(title = "system-话题管理-查询话题", businessType = CyLogTypeEnum.QUERY)
    @Operation(summary = "分页查询话题集合", description = "分页查询话题集合")
    @GetMapping(value = "/open/opmTopic/queryOpmTopicByPagination")
    public CyGridModel listByPagination(OpmTopic opmTopic) {
        opmTopicServiceImpl.findAllByPagination(getPaginationUtility(), opmTopic);
        return getGridModelResponse();
    }
}
